#!/bin/env ruby

require 'rss'
require 'open-uri'
require 'youtube-dl'
require 'sequel'
require 'date'

if ARGV.empty?
    puts "Please specify the URL of the feed as a parameter"
    exit
end

url=ARGV[0]

DB = Sequel.connect('sqlite://videos.db')
DB.create_table? :videos do
    primary_key :id
    String :url
    String :filename
    Integer :filesize
    DateTime :downloaded
end

videos=DB[:videos]

open(url) do |rss|
    feed=RSS::Parser.parse(rss)
    feed.items.each do |item|
        video=YoutubeDL.download "#{item.link}"
        videos.insert(:url => "#{item.link}",
                      :filename => "#{video.filename}",
                      :filesize => File.size("#{video.filename}"),
                      :downloaded => DateTime.now)
    end
end
